require 'minitest/autorun'
require 'digest/md5'
require 'gravatar_for'
require 'action_view'

include ActionView::Helpers::TagHelper
include GravatarFor
include ViewHelpers

module MiniTest
  class Test
    BASE_URL = GravatarFor::GRAVATAR_BASE_URL

    def email
      'user@aol.com'
    end

    def email_hash
      Digest::MD5.hexdigest(email)
    end

    def src_url
      BASE_URL + email_hash
    end

    def basic_response
      "<img alt=\"#{email}\" src=\"#{src_url}\">"
    end
  end
end

class GravatarForTest < MiniTest::Test
  def test_generate_image_tag
    assert_equal gravatar_for(email), basic_response
  end

  def test_defaults
    assert_equal gravatar_for(email, default: :mm),
      "<img alt=\"#{email}\" src=\"#{src_url}?default=mm\">"

    assert_equal gravatar_for(email, default: 404),
      "<img alt=\"#{email}\" src=\"#{src_url}?default=404\">"
  end
end
